var outMgr = {
	fMnuPath : "ide:outline",
	fOutPath : "ide:outline/des:ul.sw_out_navList",
	fMainPath : "ide:main",
	fIsLocal : window.location.protocol == "file:",

	fOut : null,
	fMain : null,
	fCls : "mnu",

	fOverflowMethod : "hidden",
	fWheelScrollFactor : 6,

	fStrings : ["défilement haut","Faire défiler le menu vers le haut",
	/*02*/      "défilement bas","Faire défiler le menu vers le bas",
	/*04*/      "Masquer le plan","Afficher le plan",
	/*06*/      "Masquer / afficher le plan","",
	/*08*/      "Ouvrir le menu \'%s\'","Fermer le menu \'%s\'"],	

	init : function(){
		this.fIsLocal = window.location.protocol == "file:";
		var vMnu = scPaLib.findNode(this.fMnuPath);
		this.fOut = scPaLib.findNode(this.fOutPath);
		this.fMain = scPaLib.findNode(this.fMainPath);
		if (!this.fOut || !this.fMain) return;

		this.fMnuFra = this.fOut.parentNode;

		// Init Scroll
		var vVisRule = null;
		if ("ScSiRuleEnsureVisible" in window) vVisRule = new ScSiRuleEnsureVisible("ide:outline/des:.mnu_sel_yes", "anc:ul.sw_out_navList");
		this.fOut.className = this.fOut.className.replace("static", "");
		this.fOut.style.overflow=this.fOverflowMethod;
		this.fSrlUp = scDynUiMgr.addElement("div", this.fMnuFra, this.fCls+"SrlUpFra", this.fOut);
		this.fSrlUpBtn = tplMgr.addBtn(this.fSrlUp, this.fCls+"SrlUpBtn", this.fStrings[0], this.fStrings[1]);
		this.fSrlUpBtn.setAttribute("aria-hiden", "true");
		this.fSrlDwn = scDynUiMgr.addElement("div", this.fMnuFra, this.fCls+"SrlDwnFra");
		this.fSrlDwnBtn = tplMgr.addBtn(this.fSrlDwn, this.fCls+"SrlDwnBtn", this.fStrings[2], this.fStrings[3]);
		this.fSrlDwnBtn.setAttribute("aria-hiden", "true");
		// Init Menu Collapser
		var vMnuTgle = scDynUiMgr.addElement("div", this.fMnuFra.parentNode.parentNode, this.fCls+"Opn",scPaLib.findNode("nsi:",this.fMnuFra.parentNode));
		this.fMnuTgleBtn = tplMgr.addBtn(vMnuTgle, this.fCls+"OpnBtn", null, this.fStrings[4]);
		vMnuTgle.onclick = function(){return outMgr.xToggleMnu()};		
		this.fMnuTgleBtn.fLbl = scDynUiMgr.addElement("span", this.fMnuTgleBtn, "btnLbl");
		this.fMnuTgleBtn.fLbl.innerHTML = this.fStrings[4];
		
		this.fMnuCollapse = tplMgr.fScreenTouch ? true : false;
		if(tplMgr.fScreenTouch) tplMgr.fStore.set("mnuCollapse","true");
		if(tplMgr.fStore.get("mnuCollapse") == "true") this.xCloseMnu(true,true);

		scOnLoads[scOnLoads.length] = this;
	},

	onLoad : function() {
		try{
		// Init Scroll up button
		this.fSrlUp.ontouchstart = function(){
			this.fIsTouched = true;
		}
		this.fSrlUp.onclick = function(){
			this.fIsTouched = false;
		}
		this.fSrlUp.onmouseover = function(){
			if (this.fIsTouched) return;
			if(outMgr.scrollTask.fSpeed >= 0) {
				outMgr.scrollTask.fSpeed = -2; 
				scTiLib.addTaskNow(outMgr.scrollTask);
			}
		}
		this.fSrlUp.onmouseout = function(){
			if (this.fIsTouched) return;
			outMgr.scrollTask.fSpeed = 0;
		}
		this.fSrlUpBtn.onclick = function(){
			outMgr.scrollTask.step(-20); 
			return false;
		}
		// Init Scroll down button
		this.fSrlDwn.ontouchstart = function(){
			this.fIsTouched = true;
		}
		this.fSrlDwn.onclick = function(){
			this.fIsTouched = false;
		}
		this.fSrlDwn.onmouseover = function(){
			if (this.fIsTouched) return;
			if(outMgr.scrollTask.fSpeed <= 0) {
				outMgr.scrollTask.fSpeed = 2; 
				scTiLib.addTaskNow(outMgr.scrollTask);
			}
		}
		this.fSrlDwn.onmouseout = function(){
			if (this.fIsTouched) return;
			outMgr.scrollTask.fSpeed = 0;
		}
		this.fSrlDwnBtn.onclick = function(){
			outMgr.scrollTask.step(20);
			return false;
		}
		// Init scroll manager
		this.scrollTask.checkBtn();
		scSiLib.addRule(this.fOut, this.scrollTask);
		this.fOut.onscroll = function(){outMgr.scrollTask.checkBtn()};
		this.fOut.onmousewheel = function(){outMgr.scrollTask.step(Math.round(-event.wheelDelta/(scCoLib.isIE ? 60 : 40)*outMgr.fWheelScrollFactor))}; //IE, Safari, Chrome, Opera.
		if(this.fOut.addEventListener) this.fOut.addEventListener('DOMMouseScroll', function(pEvent){outMgr.scrollTask.step(pEvent.detail*outMgr.fWheelScrollFactor)}, false);
		}catch(e){alert(e);}
	},

	xToggleMnu : function() {
		if (this.fMnuCollapse) return this.xOpenMnu();
		else return this.xCloseMnu();
	},

	xCloseMnu : function(pDontResize,pDontMemorize) {
		if(!pDontMemorize) tplMgr.fStore.set("mnuCollapse", "true");
		this.fMnuCollapse = true;
		tplMgr.switchClass(this.fMain, "tplMainMnu_open", "tplMainMnu_closed", true);
		tplMgr.switchClass(this.fMnuTgleBtn, this.fCls+"OpnBtn",this.fCls+"ClosedBtn", true);
		this.fMnuTgleBtn.fLbl.innerHTML = this.fStrings[5];
		if(!pDontResize) scSiLib.fireResizedNode(document.body);
		return false;
	},

	xOpenMnu : function(pDontResize,pDontMemorize) {
		if(!pDontMemorize) tplMgr.fStore.set("mnuCollapse", "false");
		this.fMnuCollapse = false;
		tplMgr.switchClass(this.fMain, "tplMainMnu_closed", "tplMainMnu_open", true);
		tplMgr.switchClass(this.fMnuTgleBtn, this.fCls+"ClosedBtn",this.fCls+"OpnBtn", true);
		this.fMnuTgleBtn.fLbl.innerHTML = this.fStrings[4];
		if(!pDontResize) scSiLib.fireResizedNode(document.body);
		return false;
	},

	/* === Tasks ============================================================== */
	/** outMgr.scrollTask : menu scroll timer & size task */
	scrollTask : {
		fClassOffUp : "btnOff",
		fClassOffDown : "btnOff",
		fSpeed : 0,
		execTask : function(){
			try {
				if(this.fSpeed == 0) return false;
				outMgr.fOut.scrollTop += this.fSpeed;
				return true;
			}catch(e){
				this.fSpeed = 0;
				return false;
			}
		},
		step: function(pPx) {
			try { outMgr.fOut.scrollTop += pPx; }catch(e){}
		},
		checkBtn: function(){
			var vScrollTop = outMgr.fOut.scrollTop;
			var vBtnUpOff = outMgr.fSrlUp.className.indexOf(this.fClassOffUp);
			if(vScrollTop <= 0) {
				if(vBtnUpOff < 0) outMgr.fSrlUp.className+= " "+this.fClassOffUp;
			} else {
				if(vBtnUpOff >= 0) outMgr.fSrlUp.className = outMgr.fSrlUp.className.substring(0, vBtnUpOff);
			}
		
			var vContentH = scSiLib.getContentHeight(outMgr.fOut);
			var vBtnDownOff = outMgr.fSrlDwn.className.indexOf(this.fClassOffDown);
			if( vContentH - vScrollTop <= outMgr.fOut.offsetHeight){
				if(vBtnDownOff < 0) outMgr.fSrlDwn.className+= " "+this.fClassOffDown;
			} else {
				if(vBtnDownOff >=0) outMgr.fSrlDwn.className = outMgr.fSrlDwn.className.substring(0, vBtnDownOff);
			}
		},
		onResizedAnc:function(pOwnerNode, pEvent){
			if(pEvent.phase==2) this.checkBtn();
		},
		ruleSortKey : "checkBtn"
	},

	loadSortKey : "Z"
}